---
title: PromiseRejectionEvent.promise
slug: Web/API/PromiseRejectionEvent/promise
tags:
  - API
  - HTML DOM
  - JavaScript
  - Promise
  - Promise Rejection Events
  - PromiseRejectionEvent
  - Promises
  - Property
  - Reference
  - events
---
<div>{{APIRef("HTML DOM") }}</div>

<p>The {{domxref("PromiseRejectionEvent")}} interface's <code><strong>promise</strong></code> read-only property indicates the JavaScript {{jsxref("Promise")}} which was rejected. You can examine the event's {{domxref("PromiseRejectionEvent.reason")}} property to learn why the promise was rejected.</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox"><em>promise</em> = <em>PromiseRejectionEvent</em>.promise</pre>

<h3 id="Value">Value</h3>

<p>The JavaScript {{jsxref("Promise")}} which was rejected, and whose rejection went unhandled.</p>

<h2 id="Examples">Examples</h2>

<p>This example listens for unhandled promises and, if the {{domxref("PromiseRejectionEvent.reason", "reason")}} is an object with a <code>code</code> field containing the text "Module not ready", it sets up an idle callback that will retry the task that failed to execute correctly.</p>

<p>{{domxref("event.preventDefault()")}} is called to indicate that the promise has now been handled.</p>

<pre class="brush: js">window.onunhandledrejection = function(event) {
  if (event.reason.code &amp;&amp; event.reason.code == "Module not ready") {
    window.requestIdleCallback(function(deadline) {
      loadModule(event.reason.moduleName)
        .then(performStartup);
    });
    event.preventDefault();
  }
}</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName('HTML WHATWG', 'webappapis.html#dom-promiserejectionevent-promise', 'PromiseRejectionEvent.promise')}}</td>
   <td>{{ Spec2('HTML WHATWG') }}</td>
   <td>Initial definition.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.PromiseRejectionEvent.promise")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li>{{SectionOnPage("/en-US/docs/Web/JavaScript/Guide/Using_promises", "Promise rejection events")}}</li>
 <li>{{jsxref("Promise")}}</li>
 <li>{{domxref("PromiseRejectionEvent")}}</li>
 <li>{{event("rejectionhandled")}}</li>
 <li>{{event("unhandledrejection")}}</li>
</ul>
